package com.cloudcross.ssp.listener;

import java.util.List;

import javax.servlet.ServletContextEvent;
import javax.servlet.ServletContextListener;

import org.apache.log4j.Logger;
import org.springframework.context.ApplicationContext;
import org.springframework.web.context.support.WebApplicationContextUtils;

import com.cloudcross.ssp.base.dao.GenericIBatisDao;
import com.cloudcross.ssp.loader.AdvertiserLoader;
import com.cloudcross.ssp.model.Advertiser;


public class ApplicationListener implements ServletContextListener{
	private static final Logger log = Logger.getLogger(ApplicationListener.class);
	
	@Override
	public void contextDestroyed(ServletContextEvent sce) {
		// TODO Auto-generated method stub
		
	}
	
	@Override
	public void contextInitialized(ServletContextEvent sce) {
		ApplicationContext context = WebApplicationContextUtils.getRequiredWebApplicationContext(sce.getServletContext());
		GenericIBatisDao myBatisDao = (GenericIBatisDao) context.getBean("iBatisDao");
		log.debug("开始将广告主信息加载到内存");
		initAdvertiser(myBatisDao);//初始化广告主代理商信息
		log.debug("广告主信息加载完毕");
	}
	
	public void initAdvertiser(GenericIBatisDao myBatisDao){
		List<Advertiser> list = myBatisDao.getList("advertiserSqlMapper.queryAgentIdAndAdvertiserId");
		for(Advertiser a:list){
			AdvertiserLoader.ADVERTISER_LIST.add(a);
		}
		AdvertiserLoader.setAgentIdAdvertiserIdMap();
	}
	
}
