package com.cloudcross.ssp.service.impl;

import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.cloudcross.ssp.base.dao.GenericIBatisDao;
import com.cloudcross.ssp.base.service.IGenericService;
import com.cloudcross.ssp.common.utils.MapBuilder;
import com.cloudcross.ssp.common.utils.Pager;
import com.cloudcross.ssp.common.utils.SqlHelper;
import com.cloudcross.ssp.model.DspAdvertiser;
import com.cloudcross.ssp.model.Item;
import com.cloudcross.ssp.service.IAptitudeAuditService;

@Service
public class AptitudeAuditService implements IAptitudeAuditService{
	
	
	@Autowired
	private GenericIBatisDao myBatisDao;
	
	@Override
	public DspAdvertiser findById(Long id) {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public int countByParams(Map<String, Object> paramMap) {
		if(paramMap.get("searchValue")==null || paramMap.get("searchValue")==""){
			paramMap.put("searchValue", null);
		}else{
		String searchValue = SqlHelper.doLike(paramMap.get("searchValue"));
		paramMap.put("value", searchValue);
		}
		return myBatisDao.get("aptitudeAuditSqlMapper.countByParamsBack", paramMap);
	}

	@Override
	public List<Map<String,Object>> findByParams(HashMap<String, Object> paramMap,
			Pager pager) {
		String searchValue = SqlHelper.doLike(paramMap.get("searchValue"));
		paramMap.put("value", searchValue);
		paramMap.put("pager", pager);
		return myBatisDao.getList("aptitudeAuditSqlMapper.selectByParamsBack", paramMap);
	}

	@Override
	public boolean add(DspAdvertiser t) {
		// TODO Auto-generated method stub
		return false;
	}

	@Override
	public boolean edit(DspAdvertiser t) {
		// TODO Auto-generated method stub
		return false;
	}

	@Override
	public boolean updatePass(List<Long> dspIdList,List<Long> advIdList, int status) {
		List<Item> arrayList = new ArrayList<Item>();
		Item item = new Item();
		for(int i=0;i<dspIdList.size();i++){
			item.setDspId(dspIdList.get(i));
			item.setAdvertiserId(advIdList.get(i));
			arrayList.add(i,item);
		}
		myBatisDao.save("aptitudeAuditSqlMapper.updateAuditPass",
				MapBuilder.create(HashMap.class)
					.add("arrayList", arrayList)
					.add("modifyDate", new Date())
					.add("checkStatus", status).map());
		return true;
	}

	@Override
	public boolean upDateNoPass(List<Long> dspIdList, List<Long> advIdList,int checkStatus,
			String memo) {
		List<Item> arrayList = new ArrayList<Item>();
		Item item = new Item();
		for(int i=0;i<dspIdList.size();i++){
			item.setDspId(dspIdList.get(i));
			item.setAdvertiserId(advIdList.get(i));
			arrayList.add(i,item);
		}
		myBatisDao.save("aptitudeAuditSqlMapper.updateAuditNoPass",
				MapBuilder.create(HashMap.class)
					.add("arrayList", arrayList)
					.add("memo",memo)
					.add("modifyDate", new Date())
					.add("checkStatus", checkStatus).map());
		return true;
	}

	@Override
	public boolean updateCheckStatus(Map<String, Object> paramMap) {
		myBatisDao.save("aptitudeAuditSqlMapper.updateCheckStatus", paramMap);
		return false;
	}

	@Override
	public List<DspAdvertiser> findDeliverEffectAnalysis(Map<String, Object> paramMap) {
		String searchValue = SqlHelper.doLike(paramMap.get("searchValue"));
		paramMap.put("value", searchValue);
		return myBatisDao.getList("aptitudeAuditSqlMapper.findDeliverEffectAnalysis", paramMap);
	}

	@Override
	public boolean updateStatus(List<Long> idList, int status) {
		// TODO Auto-generated method stub
		return false;
	}

	@Override
	public DspAdvertiser findById(Long dspId, Long advertiserId) {
		
		return myBatisDao.get("aptitudeAuditSqlMapper.selectByIdBack",
				MapBuilder.create(HashMap.class)
				.add("dspId", dspId)
				.add("advertiserId", advertiserId)
				.map());
	}

	@Override
	public List<DspAdvertiser> findByParams(Map<String, Object> paramMap,
			Pager pager) {
		// TODO Auto-generated method stub
		return null;
	}

	

}
